/*
pi with monte carlo
random numbers from the GNU Scientific Library (GSL)
GNU multiple precision functions (GMP) (not used yet)
echo "scale=40;355/113" | bc
*/

#include <stdlib.h>
#include <math.h>
#include <gsl/gsl_rng.h>
#include <sys/time.h>

int isAMD64()
{
    int r=system("grep name /proc/cpuinfo | grep \"AMD.*64\" > /dev/null")==0;
    return r;
}

int main(int argc, char* argv[])
{
/*    printf("AMD64 %d\n",isAMD64());
    if (isAMD64()) {
	printf("Error: CPU is an AMD64");
	return 1;
    }
    return 0; */

    long long i,iterations,incircle=0;
    double x,y,s;
    gsl_rng *r;
    double t;
    struct timeval tim;

    if (argc==1) {
	printf("%s [iterations]\n",argv[0]);
	return 0;
    }
    iterations=atoll(argv[1]);

    gettimeofday(&tim, NULL);
    t=tim.tv_sec+(tim.tv_usec/1000000.0);
    // printf("%.6lf\n", t);

    r=gsl_rng_alloc(gsl_rng_taus);
    gsl_rng_set(r, t);
    for (i=0; i<iterations; i++) {
	x=gsl_rng_uniform(r);
	y=gsl_rng_uniform(r);
	s=x*x + y*y;
	if (s<1) incircle++;
	// printf("%ld %f %f %f\n", i, x, y, s);
	if ((i % 10000000)==1) printf("pi %0.20f\n",(double)incircle / (double)i * 4);
    }
    printf("pi %0.20f\n",(double)incircle / (double)iterations * 4);

    gsl_rng_free(r);

    return 0;
}
